#!/bin/bash

PATH="/usr/bin/X11:$PATH"

for i in /proc/[1-9]*; do
  unset DISPLAY
  unset XAUTHORITY
  eval `xargs -r -n 1 -0 /bin/echo <$i/environ |
        egrep 'DISPLAY|XAUTHORITY'`
  if [ -n "$DISPLAY" ]; then
    export DISPLAY
    export XAUTHORITY
    if glxinfo 2>/dev/null | grep 'direct rendering: Yes' >/dev/null; then
      if test "$1" = "suspend"; then
        s=off
      elif test "$1" = "resume"; then
        s=on
      else
        s=`xset q 2>&- | sed '/Monitor is/!d;s/.*On.*/off/;s/.*Off.*/on/;q'`
      fi
      test -n "$s" && xset dpms force "$s"
      if test "$s" = off; then
        exit 1
      else
        exit 0
      fi
    fi
  fi
done
